ResourceDecorator (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.resources, class: ResourceDecorator

# Class ResourceDecorator

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.Resource
org.apache.tools.ant.types.resources.ResourceDecorator

All Implemented Interfaces:
  `Cloneable, Comparable<Resource>, Iterable<Resource>, ResourceCollection`

Direct Known Subclasses:
  `ContentTransformingResource, MappedResource`

public abstract class ResourceDecorator extends Resource
Abstract class that delegates all reading methods of Resource to its wrapped resource and deals with reference handling.

Overwrites all setters to throw exceptions.

Since:
  Ant 1.8.0

- ## Field Summary

  ### Fields inherited from class Resource

  `MAGIC, UNKNOWN_DATETIME, UNKNOWN_SIZE`
  Modifier and Type
  Field
  Description
  `protected static final int`
  `MAGIC`
  Magic number
  `static final long`
  `UNKNOWN_DATETIME`
  Constant unknown datetime for getLastModified
  `static final long`
  `UNKNOWN_SIZE`
  Constant unknown size

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `ResourceDecorator()`
  no arg constructor
  `protected`
  `ResourceDecorator(ResourceCollection other)`
  Constructor with another resource to wrap.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final void`
  `addConfigured(ResourceCollection a)`
  Sets the resource to wrap using a single-element collection.
  `<T> T`
  `as(Class<T> clazz)`
  Returns a view of this resource that implements the interface given as the argument or null if there is no such view.
  `int`
  `compareTo(Resource other)`
  Delegates to a comparison of names.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `InputStream`
  `getInputStream()`
  Get an InputStream for the Resource.
  `long`
  `getLastModified()`
  Tells the modification time in milliseconds since 01.01.1970 .
  `String`
  `getName()`
  Get the name of the resource.
  `OutputStream`
  `getOutputStream()`
  Get an OutputStream for the Resource.
  `protected final Resource`
  `getResource()`
  De-references refids if any, ensures a wrapped resource has been specified.
  `long`
  `getSize()`
  Get the size of this Resource.
  `int`
  `hashCode()`
  Get the hash code for this Resource.
  `boolean`
  `isDirectory()`
  Tells if the resource is a directory.
  `boolean`
  `isExists()`
  The exists attribute tells whether a file exists.
  `boolean`
  `isFilesystemOnly()`
  Fulfill the ResourceCollection contract.
  `void`
  `setDirectory(boolean directory)`
  Override setDirectory.
  `void`
  `setExists(boolean exists)`
  Set the exists attribute.
  `void`
  `setLastModified(long lastmodified)`
  Override setLastModified.
  `void`
  `setName(String name)`
  Overridden, not allowed to set the name of the resource.
  `void`
  `setRefid(Reference r)`
  Overrides the base version.
  `void`
  `setSize(long size)`
  Override setSize.

  ### Methods inherited from class Resource

  `asOptional, clone, equals, getMagicNumber, getRef, iterator, size, toLongString, toString`
  Modifier and Type
  Method
  Description
  `<T> Optional<T>`
  `asOptional(Class<T> clazz)`
  Return `Resource.as(Class)` as an `Optional`.
  `Object`
  `clone()`
  Clone this Resource.
  `boolean`
  `equals(Object other)`
  Implement basic Resource equality.
  `protected static int`
  `getMagicNumber(byte[] seed)`
  Create a "magic number" for use in hashCode calculations.
  `protected Resource`
  `getRef()`
  Perform the check for circular references and return the referenced Resource.
  `Iterator<Resource>`
  `iterator()`
  Fulfill the ResourceCollection contract.
  `int`
  `size()`
  Fulfill the ResourceCollection contract.
  `final String`
  `toLongString()`
  Get a long String representation of this Resource.
  `String`
  `toString()`
  Get the string representation of this Resource.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ResourceCollection

  `isEmpty, stream`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isEmpty()`
  Learn whether this `ResourceCollection` is empty.
  `default Stream<? extends Resource>`
  `stream()`
  Return a `Stream` over this `ResourceCollection`.

- ## Constructor Details

  - ### ResourceDecorator

    protected ResourceDecorator()
    no arg constructor

  - ### ResourceDecorator

    protected ResourceDecorator(ResourceCollection other)
    Constructor with another resource to wrap.
    Parameters:
      `other` - the resource to wrap.

- ## Method Details

  - ### addConfigured

    public final void addConfigured(ResourceCollection a)
    Sets the resource to wrap using a single-element collection.
    Parameters:
      `a` - the resource to wrap as a single element Resource collection.

  - ### getName

    public String getName()
    Get the name of the resource.
    Overrides:
      `getName` in class `Resource`
    Returns:
      the name of the wrapped resource.

  - ### isExists

    public boolean isExists()
    The exists attribute tells whether a file exists.
    Overrides:
      `isExists` in class `Resource`
    Returns:
      true if this resource exists.

  - ### getLastModified

    public long getLastModified()
    Tells the modification time in milliseconds since 01.01.1970 .
    Overrides:
      `getLastModified` in class `Resource`
    Returns:
      0 if the resource does not exist to mirror the behavior of `File`.

  - ### isDirectory

    public boolean isDirectory()
    Tells if the resource is a directory.
    Overrides:
      `isDirectory` in class `Resource`
    Returns:
      boolean flag indicating if the resource is a directory.

  - ### getSize

    public long getSize()
    Get the size of this Resource.
    Overrides:
      `getSize` in class `Resource`
    Returns:
      the size, as a long, 0 if the Resource does not exist (for compatibility with java.io.File), or UNKNOWN_SIZE if not known.

  - ### getInputStream

    public InputStream getInputStream() throws IOException
    Get an InputStream for the Resource.
    Overrides:
      `getInputStream` in class `Resource`
    Returns:
      an InputStream containing this Resource's content.
    Throws:
      `IOException` - if unable to provide the content of this Resource as a stream.
      `UnsupportedOperationException` - if InputStreams are not supported for this Resource type.

  - ### getOutputStream

    public OutputStream getOutputStream() throws IOException
    Get an OutputStream for the Resource.
    Overrides:
      `getOutputStream` in class `Resource`
    Returns:
      an OutputStream to which content can be written.
    Throws:
      `IOException` - if unable to provide the content of this Resource as a stream.
      `UnsupportedOperationException` - if OutputStreams are not supported for this Resource type.

  - ### isFilesystemOnly

    public boolean isFilesystemOnly()
    Fulfill the ResourceCollection contract.
    Specified by:
      `isFilesystemOnly` in interface `ResourceCollection`
    Overrides:
      `isFilesystemOnly` in class `Resource`
    Returns:
      whether this Resource is a FileProvider.

  - ### setRefid

    public void setRefid(Reference r)
    Overrides the base version.
    Overrides:
      `setRefid` in class `Resource`
    Parameters:
      `r` - the Reference to set.

  - ### as

    public <T> T as(Class<T> clazz)
    Returns a view of this resource that implements the interface given as the argument or null if there is no such view.

    This allows extension interfaces to be added to resources without growing the number of permutations of interfaces decorators/adapters need to implement.

    This implementation of the method will return the current instance itself if it can be assigned to the given class.

    Overrides:
      `as` in class `Resource`
    Type Parameters:
      `T` - desired type
    Parameters:
      `clazz` - a class
    Returns:
      resource of a desired type

  - ### compareTo

    public int compareTo(Resource other)
    Delegates to a comparison of names.
    Specified by:
      `compareTo` in interface `Comparable<Resource>`
    Overrides:
      `compareTo` in class `Resource`
    Parameters:
      `other` - the object to compare to.
    Returns:
      a negative integer, zero, or a positive integer as this Resource is less than, equal to, or greater than the specified Resource.

  - ### hashCode

    public int hashCode()
    Get the hash code for this Resource.
    Overrides:
      `hashCode` in class `Resource`
    Returns:
      hash code as int.

  - ### getResource

    protected final Resource getResource()
    De-references refids if any, ensures a wrapped resource has been specified.
    Returns:
      Resource

  - ### dieOnCircularReference

    protected void dieOnCircularReference(Stack<Object> stack, Project project) throws BuildException
    Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    If one is included, throw a BuildException created by `circularReference`.

    This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

    The general contract of this method is that it shouldn't do anything if `DataType.checked` is true and set it to true on exit.

    Overrides:
      `dieOnCircularReference` in class `DataType`
    Parameters:
      `stack` - the stack of references to check.
      `project` - the project to use to dereference the references.
    Throws:
      `BuildException` - on error.

  - ### setName

    public void setName(String name) throws BuildException
    Overridden, not allowed to set the name of the resource.
    Overrides:
      `setName` in class `Resource`
    Parameters:
      `name` - not used.
    Throws:
      `BuildException` - always.

  - ### setExists

    public void setExists(boolean exists)
    Set the exists attribute.
    Overrides:
      `setExists` in class `Resource`
    Parameters:
      `exists` - if true, this resource exists.

  - ### setLastModified

    public void setLastModified(long lastmodified) throws BuildException
    Override setLastModified.
    Overrides:
      `setLastModified` in class `Resource`
    Parameters:
      `lastmodified` - not used.
    Throws:
      `BuildException` - always.

  - ### setDirectory

    public void setDirectory(boolean directory) throws BuildException
    Override setDirectory.
    Overrides:
      `setDirectory` in class `Resource`
    Parameters:
      `directory` - not used.
    Throws:
      `BuildException` - always.

  - ### setSize

    public void setSize(long size) throws BuildException
    Override setSize.
    Overrides:
      `setSize` in class `Resource`
    Parameters:
      `size` - not used.
    Throws:
      `BuildException` - always.